from datetime import datetime,timedelta
import numpy as np
import matplotlib.dates as mdates
import matplotlib.patches as patches
import matplotlib.pyplot as plt
import matplotlib.gridspec as gridspec
from scipy.stats import linregress
from scipy.ndimage import gaussian_filter as gf
import random
from velutil import *
import time

rrd = [-710,-766,-857,-884,-941,-959,-933,-947,-896,-847,-803,-678,-589,-505,-396,-327,-232,-170,-171,-136,-173,-213,-232,-308,-325,-339,-371,-324,-331,-324,-290,-321,-307,-309,-338,-308,-332,-338,-309,-334,-319,-305,-341,-321,-343,-388,-384,-437,-449,-454,-499,-492,-508,-531,-499,-512,-490,-449,-456,-403,-383,-372,-316,-325,-284,-290,-323,-307,-347,-367,-388,-453,-471,-514,-578,-591,-658,-693,-714,-772,-773,-825,-816,-854,-844,-826,-834,-780,-753,-712,-627,-608,-541,-486,-485,-418,-394,-368,-296,-295,-242,-213,-174,-198,-177,-178,-228,-216,-262,-320,-346,-422,-445,-479,-543,-545,-585,-618,-652,-644,-674,-685,-665,-692,-672,-662,-666,-606,-584,-528,-459,-445,-378,-355,-370,-335,-372,-383,-417,-395,-434,-434,-428,-466,-441,-457,-480,-451,-470,-461,-430,-446,-406,-405,-398,-377,-327,-323,-315,-277,-306,-295,-293,-330,-318,-355,-396,-387,-436,-431,-429,-462,-429,-435,-420,-435,-389,-403,-393,-358,-377,-349,-349,-379,-347,-371,-385,-370,-409,-401,-404,-437,-428,-393,-373,-376,-323,-325,-304,-261,-281,-251,-261,-295,-279,-316,-324,-317,-354,-334,-325,-301,-319,-290,-307,-335,-312,-359,-369,-373,-423,-414,-431,-460,-440,-483,-493,-490,-531,-522,-509,-491,-516,-467,-443,-423,-344,-315,-246,-178,-165,-104,-89,-90,-43,-51,-54,-32,-52,-102,-130,-155,-237,-241,-268,-332]

plt.gca().spines['left'].set_position('zero')
plt.gca().spines['bottom'].set_bounds(0, 256)
plt.gca().spines['right'].set_color('none')
plt.gca().spines['top'].set_color('none')
plt.plot(rrd)
plt.ylabel('Counts')
plt.xlabel('Sample')
plt.savefig('fg/capture.png', dpi = 300)
plt.clf()



points = []


load_data(points, '000',3,4)


psdfp = '5k6_wtr_wait.csv'

#load_test(points)

##000 hach const filter
def no_data_rem(pt):
    pt_time = pt.get_time()
    
    del_times = [[datetime(2020,7,29, hour = 12),datetime(2020,7,29, hour = 19)],
                 [datetime(2020,9,8, hour = 10),datetime(2020,9,8, hour = 20)],
                 [datetime(2020,9,22, hour = 8),datetime(2020,9,22, hour = 17)],
                 [datetime(2020,9,29, hour = 9),datetime(2020,9,29, hour = 16)],
                 [datetime(2020,10,6, hour = 8),datetime(2020,10,7, hour = 15)],
                ]
    for rang in del_times:
        if  rang[0] < pt_time < rang[1]:
            return False
    return True
    
    
points = [pt for pt in points if no_data_rem(pt)]    




_ = 4980
# _ = 5030
pt = points[_]

psd = rpsd(psdfp)

hach_vem = pt.get_hach_vel()   

vels = [SdPoint.binconv * i*0.62 for i in range(128)] #0.62 is for the sampling frequenc asjustment.

plfft = pt.get_fft()


plt.plot(np.log(plfft))
# plt.hlines(0,0,128, colors = 'k')
plt.ylabel('Amp (arb.)')
plt.xlabel('Frequency Bin')
plt.gca().spines['left'].set_position('zero')
plt.gca().spines['bottom'].set_bounds(0, 128)
plt.gca().spines['right'].set_color('none')
plt.gca().spines['top'].set_color('none')
plt.savefig('fg/acced.png', dpi = 300)
# plt.show()
plt.clf()



alvem, alves, maxvel,dfft, ffft, psdfft,ctlow = pt.cannym(psd)


plt.plot(psdfft)
# plt.hlines(0,0,128, colors = 'k')
plt.ylabel('Amp (arb.)')
plt.xlabel('Frequency Bin')
plt.gca().spines['left'].set_position('zero')
plt.gca().spines['bottom'].set_bounds(0, 128)
plt.gca().spines['right'].set_color('none')
plt.gca().spines['top'].set_color('none')
plt.savefig('fg/white.png', dpi = 300)
# plt.show()
plt.clf()

dfft = [x for x in dfft]
ffft = [x for x in ffft]

plt.plot(dfft[0:64])
plt.hlines(0,0,64, colors = 'k')
plt.ylabel('Amp (arb.)')
plt.xlabel('Frequency Bin')
plt.gca().spines['left'].set_position('zero')
plt.gca().spines['bottom'].set_bounds(0, 64)
plt.gca().spines['bottom'].set_position(('axes',0))
plt.gca().spines['right'].set_color('none')
plt.gca().spines['top'].set_color('none')
plt.savefig('fg/conv.png', dpi = 300)
# plt.show()
plt.clf()

plt.plot(dfft[0:64], label = 'convolved spectrum')
plt.plot(list(range(38, 59)),dfft[38:59], c = 'r', label = 'low net change')
plt.plot(list(range(10, 19)),ffft[10:19], c = 'g', label = 'selected edge')
plt.hlines(0,0,64, colors = 'k')
plt.hlines(ctlow,0,64, colors = 'b', linestyles = 'dashed', label = 'threshold')
plt.vlines(alvem/(SdPoint.binconv*0.62), -1E12 , 1E2, colors = 'orange', label = 'velocity')
plt.ylabel('Amp (arb.)')
plt.xlabel('Frequency Bin')
plt.ylim([-1.5,3.5])
plt.legend()
plt.gca().spines['left'].set_position('zero')
plt.gca().spines['bottom'].set_bounds(0, 64)
plt.gca().spines['bottom'].set_position(('axes',0))
plt.gca().spines['right'].set_color('none')
plt.gca().spines['top'].set_color('none')
plt.savefig('fg/edge.png', dpi = 300)
plt.show()
plt.clf()

ax.plot(vels, plfft, label = 'raw fft')

coax.plot(vels, dfft, label = 'dfft', c = 'g')
coax.plot(vels, ffft, label = 'ffft', c = 'r')
ax.plot(vels, psdfft, label = 'whitened fft')

ax.vlines(hach_vem, 0 , 1E12, label = 'hach vel')

ax.vlines(alvem, 0 , 1E12, colors = "r", label = 'bosl vel')
coax.hlines(0,0,1E12, colors = 'k')

thresholds = [pt.thrsh]*128

coax.plot(vels,thresholds)
coax.hlines(ctlow,0,1E12, colors = 'k')

#ax.add_patch(patches.Rectangle((0,0), 4000 , pt.thrsh, facecolor="#ed092040"))

ax.yaxis.grid()
ax.set_xlim(0,64*SdPoint.binconv)
ax.set_ylim(0,25)
coax.set_xlim(0,64*SdPoint.binconv)
coax.set_ylim(-1,1)
coax.yaxis.grid()
ax.set_title(str(pt.get_time()) +"  |   " + str(pt.get_id()))
ax.set_xlabel("Velocity (mm/s)")
#ax.set_yscale('symlog')
ax.set_ylabel("Amplitude")
ax.legend(loc = 'upper right')
plt.savefig('out\\' + str(_) + '.png', dpi = 300)


ax.clear()
coax.clear()




